package com.qa.stepdefinition;

import static org.hamcrest.CoreMatchers.containsString;
import static org.hamcrest.Matchers.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.testng.Assert;

import com.qa.utilities.Util;

import cucumber.api.DataTable;
import cucumber.api.java.en.Given;
import cucumber.api.java.en.Then;
import cucumber.api.java.en.When;
import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;
import wiremock.com.fasterxml.jackson.databind.ObjectMapper;



public class Drivers_get_steps {
	private RequestSpecification request;
	private Response response;
	private ValidatableResponse json;
	private String ENDPOINT_GET_DRIVER = "http://ergast.com/api/f1/drivers";
	final static Logger logger = Logger.getLogger(Drivers_get_steps.class);
    Util util =new Util();
    String driverId;

	@Given("^a driver exists with driver id \"([^\"]*)\"$")
	public void a_driver_exists_with_driver_id(String driverid) throws Throwable {
		driverId = driverid;
	    }

	@When("^a driver details is retrieved by driver id$")
	public void a_driver_details_is_retrieved_by_driver_id() throws Throwable {
		
		response = util.get_driver(driverId);
		
		System.out.println("response: " + response.prettyPrint());
	}
	@Then("^the status code is (\\d+)$")
	public void the_status_code_is(int statusCode) throws Throwable {
	    json = response.then().statusCode(statusCode);
	    logger.info(statusCode);
	}

	@Then("^response includes the following$")
	public void response_includes_the_following(Map<String,String> responseFields) throws Throwable {
		
		for (Map.Entry<String, String> data : responseFields.entrySet()) {
			if(StringUtils.isNumeric(data.getValue())){
				json.body(data.getKey(), containsInAnyOrder(Integer.parseInt(data.getValue())));
			}
			else{
				json.body(data.getKey(), containsInAnyOrder(data.getValue()));
			}
		}
	}
}
